#include <mkl.h>

#define CELLG(i,j) ((i-1) * (N+2) + (j-1))
#define CELLD(i,j) ((i-1) * (M+1) + (j-1))

#define MAX(a,b) \
({ __typeof__ (a) _a = (a); \
   __typeof__ (b) _b = (b); \
   _a > _b ? _a : _b; })

#define PI 3.1415926535

struct csr_matrix
{
  double  *a;
  MKL_INT *ja;
  MKL_INT *ia;
};

// 4th Order mimetic matrix initialization
void initGD44(struct csr_matrix *G, struct csr_matrix *D, int N, int M,
              double alphaG, double betaG, double gammaG,
              double alphaD, double betaD, double gammaD);

// Phase/envelope misfit header
void pe_misfit(int N, double *ref, double *sig, double *pm, double *em);

